Set the "max verbosity" global to 9.
[rsync/rsync.git] / testsuite / rsync.fns
index 7508ce8..396cee6 100644 (file)
@@ -24,6 +24,15 @@ TO=${TMP}/to
 LOG=${TMP}/log
 RSYNC="$rsync_bin"
 
+# Berkley's nice.
+PATH="$PATH:/usr/ucb"
+
+if diff -u $srcdir/testsuite/rsync.fns $srcdir/testsuite/rsync.fns >/dev/null 2>&1; then
+    diffopt="-u"
+else
+    diffopt="-c"
+fi
+
 runtest() {
     echo $ECHO_N "Test $1: $ECHO_C"
     if eval "$2"
@@ -41,8 +50,12 @@ printmsg() {
 }
 
 
-rsync_ls_lR {
-    find "$@" -print | sort | xargs $TLS
+rsync_ls_lR() {
+    find "$@" -print | sort | xargs "$TOOLDIR/tls"
+}
+
+rsync_getgroups() { 
+    "$TOOLDIR/getgroups"
 }
 
 
@@ -53,7 +66,8 @@ hands_setup() {
     # Clean before creation
     rm -rf $FROM
     rm -rf $TO
-    
+
+    [ -d $TMP ] || mkdir $TMP
     [ -d $FROM ] || mkdir $FROM
     [ -d $TO ] || mkdir $TO
 
@@ -72,7 +86,7 @@ hands_setup() {
     mkdir ${FROM}/emptydir
 
     # a hundred lines of text or so
-    rsync_ls_lR ${srcdir} > ${FROM}/filelist
+    rsync_ls_lR "${srcdir}" > ${FROM}/filelist
 
     # This might fail on systems that don't have -n
     echo $ECHO_N "This file has no trailing lf$ECHO_C" > ${FROM}/nolf
@@ -94,12 +108,11 @@ hands_setup() {
 }
 
 
-
-
 ####################
 # Many machines do not have "mkdir -p", so we have to build up long paths.
 # How boring.  
 makepath () {
+    echo "        makepath $1"
     p="$1"
     (
        # Absolut Unix.
@@ -111,8 +124,12 @@ makepath () {
        # This will break if $1 contains a space.
        for c in `echo $p | tr '/' ' '`
        do 
-           [ -d "$c" ] || mkdir "$c" || return $? 
-           cd "$c" || return $?
+           if [ -d "$c" ] || mkdir "$c" 
+           then
+               cd "$c" || return $?
+           else
+               echo "failed to create $c" >&2; return $?
+           fi
        done
     )
 }
@@ -123,56 +140,46 @@ makepath () {
 # Run a test (in '$1') then compare directories $2 and $3 to see if
 # there are any difference.  If there are, explain them.
 
+# So normally basically $1 should be an rsync command, and $2 and $3
+# the source and destination directories.  This is only good when you
+# expect to transfer the whole directory exactly as is.  If some files
+# should be excluded, you might need to use something else.
+
 checkit() {
-    log=${LOG}
     failed=
-    # the log accumulates all output; we only display it if there 
-    # is a problem.
 
-    echo "Running: \"$1\""  >${log}
-    echo "">>${log}
-    eval "$1"  >>${log} 2>&1
+    # We can just write everything to stdout/stderr, because the
+    # wrapper hides it unless there is a problem.
+
+    echo "Running: \"$1\""  
+    eval "$1" 
     status=$?
     if [ $status != 0 ]; then
        failed="YES";
     fi
 
-    echo "-------------">>${log}
-    echo "check how the files compare with diff:">>${log}
-    echo "">>${log}
-    diff -cr $2 $3 >>${log} 2>&1 || failed=YES
-    echo "-------------">>${log}
-    echo "check how the directory listings compare with diff:">>${log}
-    echo "">>${log}
-    ( rsync_ls_lR "$2" ) > ${TMP}/ls-from 2>>${log}
-    ( rsync_ls_lR "$3" ) > ${TMP}/ls-to  2>>${log}
-    diff -c ${TMP}/ls-from ${TMP}/ls-to >>${log} 2>&1 || failed=YES
+    echo "-------------"
+    echo "check how the files compare with diff:"
+    echo ""
+    for f in `cd "$2"; find . -type f -print `
+    do 
+        diff $diffopt "$2"/"$f" "$3"/"$f" || failed=YES
+    done
+
+    echo "-------------"
+    echo "check how the directory listings compare with diff:"
+    echo ""
+    ( cd "$2" && rsync_ls_lR . ) > ${TMP}/ls-from 
+    ( cd "$3" && rsync_ls_lR . ) > ${TMP}/ls-to 
+    diff $diffopt ${TMP}/ls-from ${TMP}/ls-to || failed=YES
     if [ -z "${failed}" ] ; then
-       rm $log
        return 0
     else
-       cat ${log}
-       rm ${log}
        return 1
     fi
 }
 
 
-# In fact, we need a more general feature of capturing all stderr/log files,
-# and dumping them if something goes wrong.
-
-checkforlogs() {
-  # skip it if we're under debian-test
-  if test -n "${Debian}" ; then return 0 ; fi
-
-  if [ -f $1 -a -s $1 ] ; then
-       echo "Failures have occurred.  $1 follows:" >&2
-       cat $1 >&2
-       exit 1
-  fi
-}
-
-
 build_rsyncd_conf() {
     # Build an appropriate configuration file
     conf="$scratchdir/test-rsyncd.conf"
@@ -189,13 +196,90 @@ pid file = $pidfile
 use chroot = no
 hosts allow = localhost, 127.0.0.1
 log file = $logfile
+max verbosity = 9
 
-[test-from] = $scratchdir/daemon-from/
+uid = 0
+gid = 0
+
+[test-from]
+       path = $FROM
        read only = yes
 
-[test-to] = $scratchdir/daemon-to/
+[test-to]
+       path = $TO
        read only = no
 EOF
 }
 
 
+build_symlinks() {
+    fromdir="$scratchdir/from"
+    todir="$scratchdir/to"
+    mkdir "$fromdir"
+    date >"$fromdir/referent"
+    ln -s referent "$fromdir/relative"
+    ln -s "$fromdir/referent" "$fromdir/absolute"
+    ln -s nonexistent "$fromdir/dangling"
+    ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
+}
+
+test_fail() {
+    echo "$@" >&2
+    exit 1
+}
+
+test_skipped() {
+    echo "$@" >&2
+    echo "$@" > "$TMP/whyskipped"
+    exit 77
+}
+
+# It failed, but we expected that.  don't dump out error logs, 
+# because most users won't want to see them.  But do leave
+# the working directory around.
+test_xfail() {
+    echo "$@" >&2
+    exit 78
+}
+
+# Determine what shell command will appropriately test for links.
+ln -s foo "$scratchdir/testlink"
+for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
+do
+    for switch in -h -L
+    do
+        if $cmd $switch "$scratchdir/testlink" 2>/dev/null
+       then
+           # how nice
+           TEST_SYMLINK_CMD="$cmd $switch"
+           # i wonder if break 2 is portable?
+           break 2
+       fi
+   done
+done
+# ok, now get rid of it
+rm "$scratchdir/testlink"
+
+
+if [ "x$TEST_SYMLINK_CMD" = 'x' ]
+then
+    test_fail "Couldn't determine how to test for symlinks"
+else
+    echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
+fi
+       
+
+# Test whether something is a link, allowing for shell peculiarities
+is_a_link() {
+    # note the variable contains the first option and therefore is not quoted
+    $TEST_SYMLINK_CMD "$1"
+}
+
+
+# We need to set the umask to be reproducible.  Note also that when we
+# do some daemon tests as root, we will setuid() and therefore the
+# directory has to be writable by the nobody user in some cases.  The
+# best thing is probably to explicitly chmod those directories after
+# creation.
+umask 022